﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.IO;
using System.Configuration;


using FLogger4net.Constant;
using System.Xml;

namespace FLogger4net.utils
{
    public class CommUtil
    {
        //配置map
        private static Hashtable propsMap = new Hashtable();

        // 从配置文件中取得字符串的值，若无则返回默认值
        public static string getConfigByString(string keyName, string defaultValue)
        {
            string value = getConfig(keyName);
            if (value != null && value.Length > 0)
            {
                return value.Trim();
            }
            else
            {
                return defaultValue;
            }
        }

        // 将字符串转为字节数组
        public static byte[] StringToBytes(string str)
        {
            try
            {
                if (str == null || str.Length <= 0)
                {
                    return new byte[0];
                }
                else
                {
                    return System.Text.Encoding.Default.GetBytes(ConstantCLS.CFG_CHARSET_NAME);
                }
            }
            catch (Exception ex)
            {
                MessageBox("字符串转换为字节数组错误..." + ex.ToString());
            }
            return null;
        }
        // 字符串类型转换
        public static string GetBytesOfString(string sType, string strSource)
        {
            byte[] byteArray = null;
            switch (sType)
            {
                case "UTF8":
                case "UTF-8":
                    byteArray = System.Text.Encoding.UTF8.GetBytes(strSource);
                    break;
                case "ASCII":
                    byteArray = System.Text.Encoding.ASCII.GetBytes(strSource);
                    break;
            }
            return System.Text.Encoding.Default.GetString(byteArray);
        }
        private static void MessageBox(string v)
        {
            throw new NotImplementedException();
        }

        //从配置文件中取得长整型的值，若无则返回默认值
        public static long getConfigByLong(string keyName, long defaultValue)
        {
            string value = getConfig(keyName);
            if (value != null && value.Length > 0)
            {
                return long.Parse(value.Trim());
            }
            else
            {
                return defaultValue;
            }
        }

        // 从配置文件中读取字符串的值，配置文件查找顺序：1-项目根路径；2-src/main/resources
        private static string getConfig(string keyName)
        {
            string filePath = "FloggerCFG.xml";
            if (File.Exists(filePath))
            {
                XmlDocument xmldocument = new XmlDocument();
                //xmldocument.LoadXml(filePath);//LoadXml,从xml String读取
                xmldocument.Load(filePath);//LoadXml,从xml File读取

                XmlNode xn = xmldocument.SelectSingleNode("Root");
                return ((XmlElement)xn).GetAttribute(keyName);
            }
            else
            {
                return ConfigurationManager.AppSettings[keyName].ToString();
            }
        }

        //将异常的堆栈信息转为字符串
        public static String getExpStack(Exception e)
        {
            MemoryStream bo = new MemoryStream();
            StreamWriter pw = new StreamWriter(bo);
            pw.Write(e.ToString());
            return bo.ToString();
        }

    }
}
