﻿using System;
using System.Text;

namespace FLogger4net.utils
{
   public  class TimeUtil
    {
        // 获取完全格式的的日期格式:格式如 2015-10-31 10:33:25:012
        public static String getFullDateTime()
        {
            StringBuilder sb = new StringBuilder(30);
            int _year = DateTime.Now.Year; //获取年数
            int _month = DateTime.Now.Month; //获取月数
            int _day = DateTime.Now.Day; //获取天数
            int _hour = DateTime.Now.Hour; //获取小时
            int _minute = DateTime.Now.Minute; //获取分钟
            int _second = DateTime.Now.Second; //获取秒数
            int _millisecond = DateTime.Now.Millisecond; //获取毫秒数

            sb.Append(_year);
            sb.Append("-");
            if (_month < 10)
            {
                sb.Append("0");
            }
            sb.Append(_month);
            sb.Append("-");
            if (_day < 10)
            {
                sb.Append("0");
            }
            sb.Append(_day);
            sb.Append(" ");
            if (_hour < 10)
            {
                sb.Append("0");
            }
            sb.Append(_hour);
            sb.Append(":");
            if (_minute < 10)
            {
                sb.Append("0");
            }
            sb.Append(_minute);
            sb.Append(":");
            if (_second < 10)
            {
                sb.Append("0");
            }
            sb.Append(_second);
            sb.Append(":");
            if (_millisecond < 10)
            {
                sb.Append("00");
            }
            else if (_millisecond < 100)
            {
                sb.Append("0");
            }
            sb.Append(_millisecond);

            return sb.ToString();
        }

        //获取机器时间:年月日，格式如2015-10-31
        public static String getPCDate(char c)
        {
            StringBuilder sb = new StringBuilder(30);
            int _year = DateTime.Now.Year; //获取年数
            int _month = DateTime.Now.Month; //获取月数
            int _day = DateTime.Now.Day; //获取天数

            sb.Append(_year);
            sb.Append(c);
            if (_month < 10)
            {
                sb.Append("0");
            }
            sb.Append(_month);
            sb.Append(c);
            if (_day < 10)
            {
                sb.Append("0");
            }
            sb.Append(_day);

            return sb.ToString();
        }

        //获取机器时间:年月日，格式如20151031
        public static String getPCDate()
        {
            StringBuilder sb = new StringBuilder(30);
            int _year = DateTime.Now.Year; //获取年数
            int _month = DateTime.Now.Month; //获取月数
            int _day = DateTime.Now.Day; //获取天数

            sb.Append(_year);
            if (_month < 10)
            {
                sb.Append("0");
            }
            sb.Append(_month);
            if (_day < 10)
            {
                sb.Append("0");
            }
            sb.Append(_day);

            return sb.ToString();
        }

        //获取当前时间:时分秒，格式如122415，12时24分15秒
        public static String getCurrTime()
        {
            StringBuilder sb = new StringBuilder(30);
            int _hour = DateTime.Now.Hour; //获取小时
            int _minute = DateTime.Now.Minute; //获取分钟
            int _second = DateTime.Now.Second; //获取秒数
            if (_hour < 10)
            {
                sb.Append("0");
            }
            sb.Append(_hour);
            if (_minute < 10)
            {
                sb.Append("0");
            }
            sb.Append(_minute);
            if (_second < 10)
            {
                sb.Append("0");
            }
            sb.Append(_second);

            return sb.ToString();
        }

    }
}
